
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Apache select和Nginx epoll模型区别 / 憋错料</title>

    <meta name="description" content="Apache select和Nginx epoll模型区别 部分内容摘自跟老男孩学Linux运维:Web集群实战(运维人员必备书籍) http://oldboy.blog.51cto.com/2561410/1752270 1.select 和epoll模型区别 1.1.网络IO模型概述 通常来说,网络IO可以抽象成用户态和内核态之间的数据交换.一次网络数据读取操作(read),可以拆分成两个步骤:1)网卡驱动等待数据准备好(内核态)2)将数据从内核空间拷贝到进程空间(用户态).根据这两个步骤处理方式不一样,我们通常把网络IO划分成阻塞IO和非阻塞IO.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Apache select和Nginx epoll模型区别</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>部分内容摘自跟老男孩学Linux运维:Web集群实战（运维人员必备书籍）</h1>
<p><a href="http://oldboy.blog.51cto.com/2561410/1752270" rel="external nofollow noreferrer">http://oldboy.blog.51cto.com/2561410/1752270</a></p>
<h1>1.select 和epoll模型区别</h1>
<h2>1.1.网络IO模型概述</h2>
<p>通常来说，网络IO可以抽象成用户态和内核态之间的数据交换。一次网络数据读取操作（read），可以拆分成两个步骤：1）网卡驱动等待数据准备好（内核态）2）将数据从内核空间拷贝到进程空间（用户态）。根据这两个步骤处理方式不一样，我们通常把网络IO划分成阻塞IO和非阻塞IO。</p>
<p>·阻塞IO。用户调用网络IO相关的系统调用时（例如read），如果此时内核网卡还没有读取到网络数据，那么本次系统调用将会一直阻塞，直到对端系统发送的数据到达为止。如果对端一直没有发送数据，则本次调用将永远不会返回。</p>
<p>·&nbsp;非阻塞IO。当用户调用网络IO相关的系统调用时（例如read），如果此时内核网络还没有收到网络数据，那么本次系统调用将会立即返回，并返回一个EAGAIN的错误码。</p>
<p>在没有IO多路复用技术之前，由于没有一种好的方式来探测网络IO是否可读可写。因此，为了增加系统的并发连接量，一般是借助多线程或多进程的方式来增加系统的并发连接数。但是这种方式有个问题就是系统的并发连接数受限于操作系统的最大线程或进程数，并且随着操作系统的线程或进程数增加，将会引发大量的上下文切换，导致系统的性能急剧下降。为了解决这个问题，操作系统引入了IO多路转接技术（IO multiplexing）。</p>
<h2>1.2.&nbsp;&nbsp;IO多路转接技术</h2>
<p>IO多路转接技术其实就是使用select、epoll等操作系统提供的系统调用来检测IO事件的各种机制。通过select、epoll等机制，我们可以很轻松的同时管理大量的网络IO连接，并且获取到处于活跃状态的连接。当其中一个或多个发生网络IO事件时，select、epoll等系统调用就会返回相应的连接，我们就可以对这些连接进行读取或写入操作，从而完成网络数据交互。</p>
<h2>1.3.select 工作原理</h2>
<p>select函数原型：</p>
<p>int select(int nfds, fd_set *readfds, fd_set *writefds,fd_set *exceptfds, struct timeval *timeout);</p>
<p>select各个参数说明：</p>
<p>·&nbsp;&nbsp;nfds</p>
<p>这个参数的值一般设置为读集合（readfds）、写集合（writefds）以及exceptfds（异常集合）中最大的描述符（fd）+1，当然也可以设置为FD_SETSIZE。FD_SETSIZE是操作系统定义的一个宏，一般是1024。也就是说读写以及异常集合大小的最大值是1024，所以使用select最多只能管理1024个连接。如果大于1024个连接，select将会产生不确定行为。</p>
<p>·&nbsp;readfds</p>
<p>指向可读描述符集的指针，如果我们关心连接的可读事件，需要把连接的描述符设置到读集合中。</p>
<p>·writefds</p>
<p>指向可写描述符集的指针，如果我们关心连接的可写事件，需要把连接的描述符设置到可写集合中。</p>
<p>·&nbsp;exceptfds</p>
<p>指向异常描述符集的指针，如果我们关心连接的是否发生异常，需要把连接的描述符设置到异常描述符集合中。</p>
<p>·timeout</p>
<p>指select愿意等待的时间。</p>
<p>struct timeval {</p>
<p>longtv_sec;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; //秒数</p>
<p>longtv_usec;&nbsp;&nbsp;&nbsp; //微秒数</p>
<p>}</p>
<p>一般来说，分为三种情况：</p>
<p>·timeout为空，select将会永远等待。直到有连接可读、可写或者被信号中断时返回。</p>
<p>·timeout-&gt;tv_sec = 0 且 timeout-&gt;tv_usec = 0，完全不等待。检测所有指定的描述符后立即返回。这是得到多个描述符的状态而不阻塞select函数的轮询方法。</p>
<p>·timeout-&gt;tv_sec != 且 timeout-&gt;tv_usec != 0，等待指定的秒数和微秒数。当指定的描述符之一已经准备好，或者超过了指定的时间值，则立即返回。如果超时了，还没有一个描述符准备好，则返回0。</p>
<p>select的工作原理，select通过轮询来检测各个集合中的描述符（fd）的状态，如果描述符的状态发生改变，则会在该集合中设置相应的标记位；如果指定描述符的状态没有发生改变，则将该描述符从对应集合中移除。因此，select的调用复杂度是线性的，即O(n)。举个例子，一个保姆照看一群孩子，如果把孩子是否需要尿尿比作网络IO事件，select的作用就好比这个保姆挨个询问每个孩子：你要尿尿吗？如果孩子回答是，保姆则把孩子拎出来放到另外一个地方。当所有孩子询问完之后，保姆领着这些要尿尿的孩子去上厕所（处理网络IO事件）。</p>
<p>select的限制，前面提到FD_SETSIZE宏，这个宏是操作系统定义的。在linux下面通常是1024，也就是说select最多只能管理1024个描述符。如果大于1024的个描述，select将会产生不可预知的行为。那在没有poll或epoll的情况下，怎样使用select来处理连接数大于1024的情况呢？答案是使用多线程技术，每个线程单独使用一个select进行检测。这样的话，你的系统能够处理的并发连接数等于线程数*1024。早期的apache就是这种技术来支撑海量连接的。</p>
<h2>1.4.epoll工作原理</h2>
<p>epoll函数原型：</p>
<p>int epoll_create(int size);</p>
<p>intepoll_ctl(int epfd, int op, int fd, struct epoll_event *event);</p>
<p>int epoll_wait(intepfd, &nbsp;struct epoll_event *events, intmaxevents, &nbsp;int timeout);</p>
<p>epoll依赖上述三个函数，既可以完成成千上万的并发连接管理。epoll使用方式，1）通过epoll_create建立epoll句柄。2）将描述符所感兴趣的事件通过epoll_ctl添加到epoll句柄中。3）调用epoll_wait返回所有可读写的描述符。</p>
<p>epoll是<a href="http://baike.baidu.com/view/573460.htm" rel="external nofollow noreferrer">Linux内核</a>为处理大批量<a href="http://baike.baidu.com/view/1303430.htm" rel="external nofollow noreferrer">文件描述符</a>而作了改进的epoll，是Linux下多路复用IO接口select/poll的增强版本，它能显著提高程序在大量<a href="http://baike.baidu.com/view/922692.htm" rel="external nofollow noreferrer">并发连接</a>中只有少量活跃的情况下的系统CPU利用率。另一点原因就是获取事件的时候，它无须遍历整个被侦听的描述符集，只要遍历那些被内核IO事件异步唤醒而加入Ready队列的描述符集合就行了。epoll除了提供select/poll那种IO事件的水平触发（Level Triggered）外，还提供了边缘触发（Edge Triggered），这就使得用户空间程序有可能缓存IO状态，减少epoll_wait/epoll_pwait的调用，提高<a href="http://baike.baidu.com/view/330120.htm" rel="external nofollow noreferrer">应用程序</a>效率。</p>
<p>还是以保姆照看一群孩子为例，在epoll机制下，保姆不再需要挨个的询问每个孩子是否需要尿尿。取而代之的是，每个孩子如果自己需要尿尿的时候，自己主动的站到事先约定好的地方，而保姆的职责就是查看事先约定好的地方是否有孩子。如果有小孩，则领着孩子去上厕所（网络事件处理）。因此，epoll的这种机制，能够高效的处理成千上万的并发连接，而且性能不会随着连接数增加而下降。</p>
<h2>1.5.select和epoll对比</h2>
<p>综上所述，select和epoll对比如下表所示</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<br />select</p>
</td>
<td>
<br />epoll</p>
</td>
</tr>
<tr>
<td>
<br />性能</p>
</td>
<td>
<br />随着连接数增加，急剧下降。处理成千上万并发连接数时，性能很差。</p>
</td>
<td>
<br />随着连接数增加，性能基本上没有下降。处理成千上万并发连接时，性能很好。</p>
</td>
</tr>
<tr>
<td>
<br />连接数</p>
</td>
<td>
<br />连接数有限制，处理的最大连接数不超过1024。如果要处理超过1024个连接数，则需要修改FD_SETSIZE宏，并重新编译 。</p>
</td>
<td>
<br />连接数无限制。</p>
</td>
</tr>
<tr>
<td>
<br />内在处理机制</p>
</td>
<td>
<br />线性轮询</p>
</td>
<td>
<br />回调callback</p>
</td>
</tr>
<tr>
<td>
<br />开发复杂性</p>
</td>
<td>
<br />低</p>
</td>
<td>
<br />中</p>
</td>
</tr>
</tbody>
</table>
<p><strong>老男孩教育最新课程select</strong><strong>和epoll</strong><strong>简单区别比喻</strong></p>
<p>select的调用复杂度是线性的，即O(n)。举个例子，一个保姆照看一群孩子，如果把孩子是否需要尿尿比作网络IO事件，select的作用就好比这个保姆挨个询问每个孩子：你要尿尿吗？如果孩子回答是，保姆则把孩子拎出来放到另外一个地方。当所有孩子询问完之后，保姆领着这些要尿尿的孩子去上厕所（处理网络IO事件）。</p>
<p>还是以保姆照看一群孩子为例，在epoll机制下，保姆不再需要挨个的询问每个孩子是否需要尿尿。取而代之的是，每个孩子如果自己需要尿尿的时候，自己主动的站到事先约定好的地方，而保姆的职责就是查看事先约定好的地方是否有孩子。如果有小孩，则领着孩子去上厕所（网络事件处理）。因此，epoll的这种机制，能够高效的处理成千上万的并发连接，而且性能不会随着连接数增加而下降。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-17 11:54:24 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/nginx/" title="nginx">nginx</a>, <a href="https://www.biecuoliao.com/tag/web/" title="web">web</a>, <a href="https://www.biecuoliao.com/tag/linux%e5%9f%b9%e8%ae%ad/" title="linux培训">linux培训</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Apache select和Nginx epoll模型区别的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vYVaX0.html" rel="bookmark">Apache select与Nginx epoll模型区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.select 和epoll模型区别1.1.网络IO模型概述通常来说,网络IO可以抽象成用户态和内核态之间的数据交换.一次网络数据读取操作(read),可以拆分成两个步骤:1)网卡驱动等待数据准备好(内核态)2)将数据从内核空间拷贝到进程空间(用户态).根据这两个步骤处理方式不一样,我们通常把网络IO划分成阻塞IO和非阻塞IO.·阻塞IO.用户调用网络IO相关的系统调用时(例如read),如果此时内核网卡还没有读取到网络数据,那么本次系统调用将会一直阻塞,直到对端系统发送的数据到达为止.如果对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bgLrY3.html" rel="bookmark">I&sol;O多路复用之select&comma;poll，epoll的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.关于select,poll,epoll 三种IO模型,都属于多路IO就绪通知,提供了对大量文件描述符就绪检查的高性能方案,只不过实现方式有所不同: select原理概述: 调用select时,会发生以下事情: (1)从用户空间拷贝fd_set到内核空间: (2)注册回调函数__pollwait: (3)遍历所有fd,对全部指定设备做一次poll(这里的poll是一个文件操作,它有两个参数,一个是文件fd本身,一个是当设备尚未就绪时调用的回调函数__pollwait,这个函数把设备自己特有的等			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3825znM.html" rel="bookmark">Linux中select poll和epoll的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Linux Socket服务器短编程时,为了处理大量客户的连接请求,需要使用非阻塞I/O和复用,select.poll和epoll是Linux API提供的I/O复用方式,自从Linux 2.6中加入了epoll之后,在高性能服务器领域得到广泛的应用,现在比较出名的nginx就是使用epoll来实现I/O复用支持高并发,目前在高并 发的场景下,nginx越来越收到欢迎.这里有个文章参考.Nginx成为全球Top1000网站最受欢迎的Web服务器. 据 w3techs 7月 3 日的统计数据表明			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDm9EY0.html" rel="bookmark">Nginx epoll模型详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				举个例子:假设进程有10万个TCP连接,且只有几百个连接是有事件需要处理的.那么在每一个时刻进程只需要处理这几百个有事件需要处理的连接即可. 事件:即TCP连接上有数据需要交互. select和poll这样处理的:在某一时刻,进程收集所有的连接.并把所有连接的套接字传给操作系统(这个过程其实是用户态内存到内核态内存的复制),而由操作系统内核寻找这那几百个有事件需要处理的连接并处理,然后返回数据给用户. Note:这个过程需要操作系统把全部的连接处理一边,极大浪费系统资源. 而epoll是这样做的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mgq2AO3.html" rel="bookmark">epoll模型与select模型的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Nginx  ---&gt;epoll模型 Apache ---&gt;select模型 处理大量连接的读写时,Apache所采用的select网络I/O模型比较低,用两个通俗的比喻来解释二者的区别: 第一个比喻: 例如你在大学读书,住的宿舍楼有很多房间,你的朋友要来找你,select版宿管大妈就会 带着你的朋友到各个房间挨个去找,直到找到为止.而epoll版宿管大妈会先记下每位入住同学的房间号码,当你朋友来找你时,只需告诉你的朋友你住在哪个房间?不用亲自带着你的朋友满宿舍的找.如果同时来了100个人,都			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0a5LPg0.html" rel="bookmark">python 简单搭建非阻塞式单进程，select模式，epoll模式服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				由于经常被抓取文章内容,在此附上博客文章网址:,偶尔会更新某些出错的数据或文字,建议到我博客地址 :  --&gt; 点击这里 1 单进程服务器 - 非堵塞模式 服务端 : #coding=utf-8 from socket import * import time #用来存储所有的新连接的socket,这个是重点 g_socketList = [] def main(): serSocket = socket(AF_INET, SOCK_STREAM) serSocket.setsockopt(SO			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBaOaK4.html" rel="bookmark">多路复用select和epoll的区别（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				先说下本文框架,先是问题引出,然后概括两个机制的区别和联系,最后介绍每个接口的用法 一.问题引出 联系区别 问题的引出,当需要读两个以上的I/O的时候,如果使用阻塞式的I/O,那么可能长时间的阻塞在一个描述符上面,另外的描述符虽然有数据但是不能读出来,这样实时性不能满足要求,大概的解决方案有以下几种: 1.使用多进程或者多线程,但是这种方法会造成程序的复杂,而且对与进程与线程的创建维护也需要很多的开销.(Apache服务器是用的子进程的方式,优点可以隔离用户) 2.用一个进程,但是使用非阻塞的I			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mgyblr3.html" rel="bookmark">Linux下select&comma; poll和epoll IO模型的详解（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://blog.csdn.net/tianmohust/article/details/6677985 一).Epoll 介绍 Epoll 可是当前在 Linux 下开发大规模并发网络程序的热门人选, Epoll 在 Linux2.6 内核中正式引入,和 select 相似,其实都 I/O 多路复用技术而已 ,并没有什么神秘的.其实在 Linux 下设计并发网络程序,向来不缺少方法,比如典型的 Apache 模型( Process Per Connection ,简称 PPC ), TP			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rZ1p13.html" rel="bookmark">0729------Linux网络编程----------使用 select 、poll 和 epoll 模型 编写客户端程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.select 模型 1.1 select 函数原型如下,其中 nfds 表示的描述符的最大值加1(因为这里是左闭右开区间),中间三个参数分别表示要监听的不同类型描述符的集合,timeout用来表示轮询的时间间隔,这里用NULL表示无限等待. 1.2 使用 select函数编写客户端程序的一般步骤: a)初始化参数,包括初始化监听集合read_set并添加fd,以及初始化监听的最大描述符 maxfd 和select的返回值 nready: b)将read_set 赋值给 ready_set,因			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/W0jY27M.html" rel="bookmark" class="title">一个web应用的诞生&lpar;6&rpar;</a>
					<div>
						之前登录注册的功能都已经完成,但是登录成功回到首页发现还是白茫茫的一片,对的,title一直都写得博客,那么最终目的也是写出一个轻博客来,但是,在发表文章之前是不是要先记录一下登录状态呢? 用户登录  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wrry10.html" rel="bookmark" class="title">CodeForces 621A Wet Shark and Odd and Even</a>
					<div>
						水题 #include&lt;cstdio&gt; #include&lt;cstring&gt; #include&lt;cmath&gt; #include&lt;ctime&gt; #inclu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pevbVM.html" rel="bookmark" class="title">（二）Maven 基本概念&mdash;&mdash;依赖、生命周期、仓库管理、聚合&amp;amp&semi;继承</a>
					<div>
						1. 依赖配置 1.1 依赖配置主要包含如下元素: &lt;!--添加依赖配置--&gt; &lt;dependencies&gt; &lt;!--项目要使用到junit的jar包,所以在这里添加ju ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz8D7q3.html" rel="bookmark" class="title">向linux服务器上传下载文件方式收集</a>
					<div>
						向linux服务器上传下载文件方式收集 1. scp [优点]简单方便,安全可靠:支持限速参数[缺点]不支持排除目录[用法] scp就是secure copy,是用来进行远程文件拷贝的.数据传输使用  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLDAOeM.html" rel="bookmark" class="title">tcl之文件操作</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nE6EjM.html" rel="bookmark" class="title">HDU2352 Verdis Quo</a>
					<div>
						问题链接:HDU2352 Verdis Quo. 这个问题是将罗马数转换为阿拉伯数的问题. 阿拉伯记数法是最为方便的记数方法,为世界的人们所普遍采用. 这个问题用C++编程比较方便简洁. AC的C++ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d5gLn3.html" rel="bookmark" class="title">netty 对象序列化传输示例</a>
					<div>
						package object.server.impl; import io.netty.bootstrap.ServerBootstrap; import io.netty.channel.Chann ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4p5mmPM.html" rel="bookmark" class="title">数据库查询的基本方法，有很多不全的地方，自己学习使用</a>
					<div>
						简单查询: 一.查询表名和列名 select *from  表名 select  列1,列2···from 表名 select distinct 列名 from表名            去重只能是一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz1aky4.html" rel="bookmark" class="title">第12章线程控制总结</a>
					<div>
						1 线程属性 线程属性:pthread_attr_t int pthread_attr_init(pthread_attr_t *attr) int pthread_attr_destroy(pthr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lWBnPM.html" rel="bookmark" class="title">关于分布式Session 的几种实现方式</a>
					<div>
						分布式Session的几种实现方式 1.基于数据库的Session共享 2.基于NFS共享文件系统 3.基于memcached 的session,如何保证 memcached 本身的高可用性? 4.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JYXmY3.html" rel="bookmark" class="title">类的再理解</a>
					<div>
						参考资料: http://zhidao.baidu.com/link?url=Fjt8F2-hATIAzY3lvj8aMUNuKoHhkaH8K0ixvJCHMQdwmob5NRDaYAVGBBXo4 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzAa2q4.html" rel="bookmark" class="title">Hadoop任务优化建议 - 【Dr&period;Elephant系列文章-6】</a>
					<div>
						使用Dr.Elephant来分析我们的任务,可以知道有哪些地方可以进行优化. 加速你的任务流程 对于特定的任务,最好有特定的参数配置.对于很多的应用场景来说,默认的任务配置并不能保证每个任务都有最好的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xvy9L4.html" rel="bookmark" class="title">奇怪的string</a>
					<div>
						代码1: 1 #include &lt;iostream&gt; 2 //#include &lt;string&gt; 3 using namespace std; 4 5 int main(int ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLZlNW3.html" rel="bookmark" class="title">几种源码管理工具的使用</a>
					<div>
						由于之前已经实际使用了SVN和github,并在上周上课的过程中听了两位同学介绍了关于SVN和GitHub的使用教程,在廖老师的介绍下,并搜索有关的资料,对几种代码托管软件进行了使用,在使用过程中有以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rzN893.html" rel="bookmark" class="title">100根火柴，拿到最后一根火柴就赢的必胜解法及思路</a>
					<div>
						问题:100根火柴,两个人轮流取,每个人每次只能取1~7根,谁拿到最后一根火柴谁赢:问有必胜策略吗,有的话是先手还是后手必胜? 最近读了刘未鹏的博文“跟波利亚学解题”有感.我也尝试使用博文中提到的一下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qRp8p4.html" rel="bookmark" class="title">shell脚本解析6----case语句</a>
					<div>
						BASH中的case结构,可以用于进行多项分支. case &quot;$var&quot; in condition1) ;; condition2) ;; *) default statments ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rbdvv3.html" rel="bookmark" class="title">cocos2d-x使用DragonBones动画</a>
					<div>
						前言 在网上查找关于DragonBones在cocos2d-x的使用教程,找了大半天也没有找到一个有用的.在自己摸索了一段时间终于摸索了出来,在这里记下分享给大家. 下载DragonBones 我这里 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rbG9l3.html" rel="bookmark" class="title">AM335x内核模块驱动之LED</a>
					<div>
						在Ubuntu的任意可操作的文件才建立text目录 在text中建立zyr-hello.c: #include&lt;linux/kernel.h&gt; #include&lt;linux/modu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoL2Gx0.html" rel="bookmark" class="title">angular-file-upload&plus;struts的使用</a>
					<div>
						参考帖子 http://www.cnblogs.com/wangzun/p/6099884.html http://www.cnblogs.com/highriver/archive/2011/06/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47XKVoM.html" rel="bookmark" class="title">【原创】datalist repeater 控件的行鼠标单击 以及 滑过特效</a>
					<div>
						原文发布时间为:2009-05-06 -- 来源于本人的百度文章 [由搬家工具导入] 调用方法如：&lt;tr id=&quot;&lt;%# Container.ItemIndex+1 %&gt;& ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
